/*

BigBump library by ACWraith

--------------------------------------------------------------------------------------------------
Before using this library, recognize the following possible conflicts:
	This library overwrites
		atom/movable/Del()
		atom/movable/Move()
		turf/Enter()
		turf/Entered()
		turf/Exited()
	This library reserves the prefix bb_.
	You will have to use the procs this library provides for when turfs are entered and exited.
--------------------------------------------------------------------------------------------------

This library allows normal size movables to physically mimic being a larger size
without extra movables.  Graphical enhancements are not a part of this library.

The turfs the movable takes space on are kept track of.

When a movable moves, all of the turfs that it failed to enter are sent to its bb_BigBump() proc
and the movement fails.  By default, bb_BigBump() itself does absolutely nothing.

//////////////////////////////////////////////////////////////////////////////////////////////////
atom/movable

bb_isSingleFromNull		= TRUE
	This allows all of the partial blocks to be ignored when moving from null.
	Not being able to move is one thing.  Not seeing the darn thing on the map can drive you crazy. ;)

bb_isSingleFromNonTurf	= TRUE
	This allows all of the partial blocks to be ignored when moving from anything which is not a turf.

bb_BigBump(turf/NewLoc,list/Turfs)
	This is the whole point of this library.
	What does it do by default?  Absolutely nothing!
	Turfs is every turf that could not be entered when the movable tried to move to NewLoc.
	There are multiple reasons for a movable not to be able to enter a turf.
	For instance, there could be density issues,
	or you could simply have disallowed such movement in your own code.
	Test for whatever the case is and react however you want.

bb_GetBlockedTurfs(turf/Loc,Dir)
	Returns all turfs that block src from entering Loc while facing Dir.
	By default, this returns any new turfs that fail their enter proc
	or are in areas that can't be entered.
	If this list has a positive length then Loc can not be entered
	and the list will be sent to bb_BigBump().

bb_GetClaimedTurfs()
	Returns all turfs assigned to src.

bb_PredictTurfs(turf/Loc,Dir)
	Get all turfs assigned to a src as if it was standing at Loc and facing Dir.
	By default, if Loc was a turf then a list containing Loc is returned.
	If Loc was not a turf, then an empty list is returned.

//////////////////////////////////////////////////////////////////////////////////////////////////
turf

bb_AssignTurfs(atom/movable/Bumper,list/Turfs)
	Remove any of Bumper's old claims and claim Turfs for Bumper.

The following procs take the place of Entered() and Exited().
YOU SHOULD BASE YOUR DERIVATIVES ON THESE.

	bb_EnteredBase(atom/movable/Obj,atom/OldLoc)
		Obj is actually contained on src.
	bb_EnteredPiece(atom/movable/Obj,atom/OldLoc)
		Part of obj "entered" src, but Obj is not actually stored on src.

	bb_ExitedBase(atom/movable/Obj)
		Obj actually left src.
	bb_ExitedPiece(atom/movable/Obj)
		Part of obj "exited" src, but Obj was not actually stored on src.

bb_GetWhatClaims()
	Returns a list of all movables that claim src.

bb_ReleaseAllTurfs()
	Clears all claimed turfs and returns TRUE.

*/