world
	view	= "63x21"
	area	= /area/Demo/Floor
	mob		= /mob/Demo
	turf	= /turf/Demo

atom
	icon	= 'ignore.dmi'

//////////////////////////////////////////////////////////////////////////////////////////////////
area/Demo/Floor
	icon_state	= "floor"

area/Demo/Wall
	icon_state	= "wall"

//////////////////////////////////////////////////////////////////////////////////////////////////
turf/Demo
	mouse_opacity	= 2

	New(Loc)
		..(Loc)
		src.name	= "[src.x],[src.y]"

	Click(location,control,params)
		if (location != src)	return ..(location,control,params)
		var/area/A
		if ( istype(src.loc,/area/Demo/Floor) )
			A			= locate(/area/Demo/Wall) in world.contents
			A.contents	+= src
		else
			A			= locate(/area/Demo/Floor) in world.contents
			A.contents	+= src

	bb_AssignTurfs(atom/movable/Bumper,list/Turfs)
		var/turf/T
		if (istype(Bumper))	for(T in Bumper.bb_GetClaimedTurfs())	T.overlays	-= Bumper.ignore_gIBounds
		.	= ..(Bumper,Turfs)
		if (istype(Bumper))	for(T in Bumper.bb_GetClaimedTurfs())	T.overlays	+= Bumper.ignore_gIBounds

//////////////////////////////////////////////////////////////////////////////////////////////////
atom/movable
	mouse_opacity	= 2

	var
		image/ignore_gIBounds
		ignore_boundState		= "bounds"
		ignore_markExits		= TRUE

	New(Loc)
		..(Loc)
		src.ignore_gIBounds	= image('ignore.dmi',null,src.ignore_boundState,OBJ_LAYER,0)

	Click(location,control,params)
		if (!istype(location,/turf) || !istype(usr,/mob/Demo))	return ..(location,control,params)
		var/mob/Demo/M	= usr
		M.ignore_SetEdit(src)

//////////////////////////////////////////////////////////////////////////////////////////////////
obj/Demo/Wanderer
	icon_state			= "wanderer"
	layer				= MOB_LAYER
	ignore_boundState	= "bounds"

//////////////////////////////////////////////////////////////////////////////////////////////////
mob/Demo
	icon_state			= "player"
	ignore_boundState	= "playerbounds"

	var/atom/movable/ignore_editM

	Login()
		..()
		src.ignore_SetEdit(src)
		src	<<	output("Click a turf to toggle whether it is a floor or wall.","out")
		src	<<	output("Toggle Markers sets whether exits or entrances are shown.","out")
		src	<<	output("Click a movable to select it for editing.","out")
		src	<<	output("<- Edit bounds by selecting a rectangle vertex on the left.","out")
		src	<<	output("(This is a demo. The library has no shape restrictions.)","out")

	proc
		ignore_SetEdit(atom/movable/E)
			if (!istype(E))	return FALSE
			src.ignore_editM	= E
			src					<< output(src.ignore_editM.name,"edit")
			return TRUE

	verb
		setlowerbounds(X as num, Y as num)
			if ( !istype(src.ignore_editM) )	src.ignore_SetEdit(src)
			src.ignore_editM.SetBounds(X,Y,src.ignore_editM.x2,src.ignore_editM.y2)

		setupperbounds(X as num, Y as num)
			if ( !istype(src.ignore_editM) )	src.ignore_SetEdit(src)
			src.ignore_editM.SetBounds(src.ignore_editM.x1,src.ignore_editM.y1,X,Y)

		togglemarkers()
			if ( !istype(src.ignore_editM) )	src.ignore_SetEdit(src)
			src.ignore_editM.ignore_markExits	= !src.ignore_editM.ignore_markExits
