turf

	//============================================================================================
	//--------------------------------------------------------------------------------------------
	Enter(atom/movable/O)
		.			= ..(O)
		if ( !(.) )	return .

		//	Collide with claims?
		if (O.density)
			var/list/whatClaims						= src.bb_GetWhatClaims()
			if (length(whatClaims) <= 0)			return TRUE
			for(var/atom/movable/WC in whatClaims)	if (WC.density && (WC != O))	return FALSE

	//--------------------------------------------------------------------------------------------
	Entered(atom/movable/Obj,atom/OldLoc)
		//	Claim Obj's bounding box.
		var/list/newTurfs	= Obj.bb_PredictTurfs(src,Obj.dir)
		src.bb_AssignTurfs(Obj,newTurfs)

		//	Enter base.
		src.bb_EnteredBase(Obj,OldLoc)
		newTurfs			-= src

		//	Enter pieces.
		var/turf/T
		//	The last base may become a piece.
		if (istype(OldLoc,/turf) && (OldLoc in newTurfs))
			newTurfs		-= OldLoc
			T				= OldLoc
			T.bb_EnteredPiece(Obj,OldLoc)
		//	Alert only the new turfs.
		newTurfs			-= Obj.bb_PredictTurfs(OldLoc,Obj.bb_oldDir)
		for(T in newTurfs)	T.bb_EnteredPiece(Obj,OldLoc)

		..(Obj,OldLoc)

	//--------------------------------------------------------------------------------------------
	Exited(atom/movable/Obj)
		//	Get old turfs before reassigning.
		var/list/exitedTurfs	= Obj.bb_GetClaimedTurfs() - Obj.bb_PredictTurfs(Obj.loc,Obj.dir)
		exitedTurfs				-= src

		//	Remove Obj's bounding box.
		src.bb_AssignTurfs(Obj,null)

		//	Exit base and then the pieces.
		src.bb_ExitedBase(Obj)
		for(var/turf/T in exitedTurfs)	T.bb_ExitedPiece(Obj)

		..(Obj)

	//============================================================================================
	var/global/list
		//	movable,turf,turf,...movable,turf,turf...
		bb_gTurfsPerMovable	= list()

	//============================================================================================
	proc
		//----------------------------------------------------------------------------------------
		//	Remove any of Bumper's old claims and claim Turfs for Bumper.
		bb_AssignTurfs(atom/movable/Bumper,list/Turfs)
			if ( !istype(Bumper) )			return FALSE

			//	Remove the old.
			var/startIndex					= src.bb_gTurfsPerMovable.Find(Bumper)
			if (startIndex)
				//	Movables are followed by their turfs in the list.
				//	Multiple movables can claim the same turf so use Cut().
				var/endIndex				= startIndex + 1
				while(endIndex <= length(src.bb_gTurfsPerMovable))
					if ( !istype(src.bb_gTurfsPerMovable[endIndex],/turf) )	break
					endIndex++
				src.bb_gTurfsPerMovable.Cut(startIndex,endIndex)

			//	Add the new.
			if ( istype(Bumper) )
				src.bb_gTurfsPerMovable		+= Bumper
				//	Go one by one in case the list is mixed.
				for(var/turf/T in Turfs)	src.bb_gTurfsPerMovable		+= T

			return TRUE

		//----------------------------------------------------------------------------------------
		//	Obj is actually contained on src.
		bb_EnteredBase(atom/movable/Obj,atom/OldLoc)

		//----------------------------------------------------------------------------------------
		//	Part of obj "entered" src, but Obj is not actually stored on src.
		bb_EnteredPiece(atom/movable/Obj,atom/OldLoc)

		//----------------------------------------------------------------------------------------
		//	Obj actually left src.
		bb_ExitedBase(atom/movable/Obj)

		//----------------------------------------------------------------------------------------
		//	Part of obj "exited" src, but Obj was not actually stored on src.
		bb_ExitedPiece(atom/movable/Obj)

		//----------------------------------------------------------------------------------------
		//	Returns a list of all movables that claim src.
		bb_GetWhatClaims()
			var/startIndex			= src.bb_gTurfsPerMovable.Find(src)

			//	Not claimed?
			if (startIndex <= 0)	return list()

			.						= list()
			var/index
			while(startIndex)
				//	The stored list contains the movable followed by its turfs.
				//	Stop when a non-turf is reached.
				index				= startIndex - 1
				while(index)
					if (!istype(src.bb_gTurfsPerMovable[index],/turf))
						.			+= src.bb_gTurfsPerMovable[index]
						break
					index--

				startIndex			= src.bb_gTurfsPerMovable.Find(src,startIndex+1,0)

		//----------------------------------------------------------------------------------------
		//	Clears all claimed turfs and returns TRUE.
		bb_ReleaseAllTurfs()
			src.bb_gTurfsPerMovable.Cut()
			return TRUE
